"use strict";

this.name = "rescue-stations-market";
this.author = "spara";
this.copyright = "2015 spara";
this.license     = "CC BY-NC-SA 4.0";

this.$originalDefsWayStation = {
      "food" : [0, 0, 28,  -2, 0,  0,  3,  0,  0],
      "textiles" : [0, 0, 30,  -1, 0,  0,  3,  0,  0],
      "radioactives" : [0, 0, 50,  -3, -1, 6,  7,  3,  0],
      "slaves" : [0, 0, 25,  0,  0,  0,  0,  0,  0],
      "liquor_wines" : [0, 0, 75,  -5, 0,  0,  15, 0,  0],
      "narcotics" : [0, 0, 50,  0,  0,  0,  0,  0,  0],
      "computers" : [0, 0, 160, 9,  9,  2,  7,  7,  0],
      "machinery" : [0, 0, 120, 4,  4,  4,  7,  7,  0],
      "alloys" : [0, 0, 80,  1,  1,  10, 15, 15, 0]
};

this.$originalDefsHQ = {
      "food" : [0, 0, 22,  -2, 0,  0,  3,  0,  0],
      "radioactives" : [0, 0, 60,  -3, 0,  0,  7,  0,  0],
      "computers" : [0, 0, 160, 9,  9,  2,  7,  7,  0],
      "machinery" : [0, 0, 120, 4,  4,  4,  7,  7,  0],
      "alloys" : [0, 0, 80,  1,  1,  10, 15, 15, 0],
      "furs" : [0, 0, 24,  -1, -1, 85, 3,  3,  0]
};

this.updateLocalCommodityDefinition = function(goodDefinition, station) {
	var commodity = goodDefinition.key;
	if (station.dataKey === "rescue_station")
		var oldDefs = this.$originalDefsWayStation[commodity];
	else var oldDefs = this.$originalDefsHQ[commodity];
	
	//these are smallish markets
	goodDefinition.capacity = 31;
	
	//old style definition found for the good. calculate it the old way
	if (oldDefs) {
		var market_base_price = oldDefs[2];
		var market_eco_adjust_price = oldDefs[3];
		var market_eco_adjust_quantity = oldDefs[4];
		var market_base_quantity = oldDefs[5];
		var market_mask_price = oldDefs[6];
		var market_mask_quantity = oldDefs[7];
		var market_rnd = Math.floor(Math.random() * 256);

		var economy = system.economy;
		
		var price = (market_base_price + (market_rnd & market_mask_price) + (economy * market_eco_adjust_price)) & 255;
		price *= 0.4;
		
		var quantity = (market_base_quantity + (market_rnd & market_mask_quantity) - (economy * market_eco_adjust_quantity)) & 255;
		if (quantity > 127) quantity = 0;
		
		quantity &= 63;
		
		goodDefinition.quantity = quantity;
		goodDefinition.price = price * 10;
	}
	//no definition found. good is not tradeable
	else {
		goodDefinition.price = 0.0;
		goodDefinition.quantity = 0;
		goodDefinition.capacity = 0;
	}
	return goodDefinition;
};
